#encoding: utf-8
# require "fixname/version"

module Fixname
  
  def titleize string
    string.split(/(\W)/).map(&:capitalize).join
  end

  def normalise
    # replace spoecial characters with normal ones
    begin
      self.tr(
        "#{}()'.,;_&0123456789ÀÁÂÃÄÅàáâãäåĀāĂăĄąÇçĆćĈĉĊċČčÐðĎďĐđÈÉÊËèéêëĒēĔĕĖėĘęĚěĜĝĞğĠġĢģĤĥĦħÌÍÎÏìíîïĨĩĪīĬĭĮįİıĴĵĶķĸĹĺĻļĽľĿŀŁłÑñŃńŅņŇňŉŊŋÒÓÔÕÖØòóôõöøŌōŎŏŐőŔŕŖŗŘřŚśŜŝŞşŠšſŢţŤťŦŧÙÚÛÜùúûüŨũŪūŬŭŮůŰűŲųŴŵÝýÿŶŷŸŹźŻżŽž",
        "                   AAAAAAaaaaaaAaAaAaCcCcCcCcCcDdDdDdEEEEeeeeEeEeEeEeEeGgGgGgGgHhHhIIIIiiiiIiIiIiIiIiJjKkkLlLlLlLlLlNnNnNnNnnNnOOOOOOooooooOoOoOoRrRrRrSsSsSsSssTtTtTtUUUUuuuuUuUuUuUuUuUuWwYyyYyYZzZzZz"
       ).downcase.gsub(/  +/," ").split(" ").sort.join("_")
    rescue
      puts self
      puts $!
    end
  end

  def check_filename file
    basename = File.basename(file)
    path = File.dirname(file)
    ext = basename.rpartition('.').last.downcase
    parts = basename.split(/-/).map!{|part|part.strip}
    parts[0] = parts.first.split(/&/).map! do |author| #wissel voor en achternaam bij ,
     before, after = author.split(/,/).map!{|part|part.strip}
     author = "#{after} #{before}"
    end.join(" & ")
    result = parts.join(" - ")
    begin
     result.gsub!(/\[(.*?)\]/," ") #verwijder alles tussen rechte haken
     result.gsub!(/\(.*\)/i," ") #verwijder alles tussen haken
     result.gsub!(/_+/," ") #vervang _ door spatie
     result.gsub!(/\\\\/,"/") #nodig ?  vervang \\ door /
     result.gsub!(/\.mobi|\.pdf|\.prc|\.doc/i,"")
     formats = "(mobi|lit|epub|azw|txt|rtf|lrf|html|htm|azw3)"
     pattern = /\.#{formats}/i
     result.gsub!(pattern,"")
     pattern = /\(#{formats}\)?/i
     result.gsub!(pattern,"")
     result.gsub!(/- *-/," - ") #verwijder opeenvolgende - eventueel gescheiden door spatie
     result.gsub!(/  +/," ") #vervang meerder spaties door één
     result.gsub!(/\(\)/,"") #vervang lege haakjes
     result.gsub!(/ *-*\./,".") #vervang spatie gevolgd door punt
     result.gsub!(/ *- *$/,"") #vervang streepje aan het einde
     result.strip!
     result = titleize(result)
    end
    result = path+'/'+result+"."+ext
    result.gsub('?',"'").gsub("./",'')
  end

  def rename old_name, new_name
    # puts %Q{ren "#{old_name}" "#{new_name}"}
    puts new_name
    system(%Q{move /y "#{old_name}" "#{new_name}"})
  rescue => e
    puts e
    puts e.backtrace
  end

  def fix old_name
    result = File.join(File.dirname(old_name), check_filename(File.basename(old_name))).gsub("/",'\\')
    if old_name != result
      old_name = old_name.gsub("/",'\\')
      # puts "  #{old_name}"
      # puts "=>#{result}"
    end
    result
  rescue => e
    puts e
    puts e.backtrace
  end

  def fixname *paths

    if paths
      paths = [paths].flatten
    elsif ARGV.length == 0
      puts "No path given.."
      abort "No path given.."
    else
      paths = ARGV
    end

    paths.each do |old_name|
      if File.directory?(old_name)
        old_name = old_name.gsub(/\\/,'/')
        puts "#{old_name} is a folder\n"
        Dir.glob("#{old_name}/*.*").each do |old_name|
          begin
            rename old_name, fix(old_name)
          rescue => e
            puts e
            puts e.backtrace
            sleep 2
          end
        end
      else
        rename old_name, fix(old_name)
      end
    end
  rescue => e
    puts e
    puts e.backtrace
  end

  module_function :fix
  module_function :fixname
  module_function :check_filename
  module_function :titleize

end


